/*

Provides a Vue 3 component that displays a form for generating reports.

Requires a GuestInfoBackend that implements GuestInfoAPI v1.0.3


*/

<template>
  <div class="bnm-reports">
    <h1>{{ msg }}</h1>

    <p></p>
    <label>Start date: </label>
    <input type="date" class="form-control" v-model="startDate">

    <p></p>
    <label>End date: </label>
    <input type="date" class="form-control" v-model="endDate">

    <p></p>
    <button @click="getReport(startDate, endDate)">Submit</button>
  </div>
</template>
    
    
<script>
import axios from 'axios';
import { parse } from 'json2csv';
import { BACKEND_BASE_URL } from '../env.js'

export default {
  name: 'getReport',
  data() {
    return {
      report: null,
      status: 'loading', // loaded, errored
    }
  },
  props: {
    msg: String
  },
  async mounted() {

  },
  methods: {

    async getReport(startDate, endDate) {
      try {
        let reportUrl = BACKEND_BASE_URL + "/visits/" + startDate + "+" + endDate;

        console.log(reportUrl);
        let response = await axios.get(reportUrl);
        this.report = response.data;
        this.status = 'loaded';
        this.downloadCSVfile(parse(this.report.visits));

      } catch (error) {
        console.error(error);
        this.status = 'errored';
      }
    },

    downloadCSVfile(data) {
      var csvFile;
      var downloadLink;

      csvFile = new Blob([data], { type: 'text/csv' });
      downloadLink = document.createElement("a");
      downloadLink.download = "guest_history_.csv";
      downloadLink.href = window.URL.createObjectURL(csvFile);
      downloadLink.style.display = "none";

      document.body.appendChild(downloadLink);
      downloadLink.click();
    }

  }

}
</script>
    
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.guestIdField {
  min-height: 5vh;
  min-width: 20vw;
  max-width: 25vw;
  margin: 0 10px 10px 0;
  font-size: 20px;
  color: black;
}
</style>
